CBCBlockCipher (Bouncy Castle Library 1.85 API Specification)
Date: 2026-07-12

org.bouncycastle.crypto.modes

## Class CBCBlockCipher

- java.lang.Object
- - org.bouncycastle.crypto.DefaultMultiBlockCipher
  - - org.bouncycastle.crypto.modes.CBCBlockCipher

- All Implemented Interfaces:
    BlockCipher, CBCModeCipher, MultiBlockCipher

      public class CBCBlockCipher
      extends DefaultMultiBlockCipher
      implements CBCModeCipher

  implements Cipher-Block-Chaining (CBC) mode on top of a simple cipher.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `CBCBlockCipher(BlockCipher cipher)` Deprecated. use the CBCBlockCipher.newInstance() static method.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String` | `getAlgorithmName()` return the algorithm name and mode.
    `int` | `getBlockSize()` return the block size of the underlying cipher.
    `BlockCipher` | `getUnderlyingCipher()` return the underlying block cipher that we are wrapping.
    `void` | `init(boolean encrypting, CipherParameters params)` Initialise the cipher and, possibly, the initialisation vector (IV).
    `static CBCModeCipher` | `newInstance(BlockCipher cipher)` Return a new CBC mode cipher based on the passed in base cipher
    `int` | `processBlock(byte[] in, int inOff, byte[] out, int outOff)` Process one block of input from the array in and write it to the out array.
    `void` | `reset()` reset the chaining vector back to the IV and reset the underlying cipher.

    - ### Methods inherited from class org.bouncycastle.crypto.DefaultMultiBlockCipher

      `getMultiBlockSize, processBlocks`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.bouncycastle.crypto.MultiBlockCipher

      `getMultiBlockSize, processBlocks`

- - ### Constructor Detail

    - #### CBCBlockCipher

          public CBCBlockCipher(BlockCipher cipher)

      Deprecated. use the CBCBlockCipher.newInstance() static method.
      Basic constructor.
      Parameters:
        `cipher` - the block cipher to be used as the basis of chaining.

  - ### Method Detail

    - #### newInstance

          public static CBCModeCipher newInstance(BlockCipher cipher)

      Return a new CBC mode cipher based on the passed in base cipher
      Parameters:
        `cipher` - the base cipher for the CBC mode.

    - #### getUnderlyingCipher

          public BlockCipher getUnderlyingCipher()

      return the underlying block cipher that we are wrapping.
      Specified by:
        `getUnderlyingCipher` in interface `CBCModeCipher`
      Returns:
        the underlying block cipher that we are wrapping.

    - #### init

          public void init(boolean encrypting,
                           CipherParameters params)
                    throws java.lang.IllegalArgumentException

      Initialise the cipher and, possibly, the initialisation vector (IV). If an IV isn't passed as part of the parameter, the IV will be all zeros.
      Specified by:
        `init` in interface `BlockCipher`
      Parameters:
        `encrypting` - if true the cipher is initialised for encryption, if false for decryption.
        `params` - the key and other data required by the cipher.
      Throws:
        `java.lang.IllegalArgumentException` - if the params argument is inappropriate.

    - #### getAlgorithmName

          public java.lang.String getAlgorithmName()

      return the algorithm name and mode.
      Specified by:
        `getAlgorithmName` in interface `BlockCipher`
      Returns:
        the name of the underlying algorithm followed by "/CBC".

    - #### getBlockSize

          public int getBlockSize()

      return the block size of the underlying cipher.
      Specified by:
        `getBlockSize` in interface `BlockCipher`
      Returns:
        the block size of the underlying cipher.

    - #### processBlock

          public int processBlock(byte[] in,
                                  int inOff,
                                  byte[] out,
                                  int outOff)
                           throws DataLengthException,
                                  java.lang.IllegalStateException

      Process one block of input from the array in and write it to the out array.
      Specified by:
        `processBlock` in interface `BlockCipher`
      Parameters:
        `in` - the array containing the input data.
        `inOff` - offset into the in array the data starts at.
        `out` - the array the output data will be copied into.
        `outOff` - the offset into the out array the output will start at.
      Returns:
        the number of bytes processed and produced.
      Throws:
        `DataLengthException` - if there isn't enough data in in, or space in out.
        `java.lang.IllegalStateException` - if the cipher isn't initialised.

    - #### reset

          public void reset()

      reset the chaining vector back to the IV and reset the underlying cipher.
      Specified by:
        `reset` in interface `BlockCipher`